From 82ded08cd54b40f67d04fded61ce8de647771572 Mon Sep 17 00:00:00 2001
From: vahit <vahid.maani@gmail.com>
Date: Fri, 30 Dec 2016 20:57:51 +0330
Subject: [PATCH] first vertion of pass with item info feature.

---
 src/password-store.sh | 27 ++++++++++++++++++++++++++-
 1 file changed, 26 insertions(+), 1 deletion(-)

diff --git a/src/password-store.sh b/src/password-store.sh
index a5a8002..83999f9 100755
--- a/src/password-store.sh
+++ b/src/password-store.sh
@@ -240,6 +240,8 @@ cmd_usage() {
 	        List passwords.
 	    $PROGRAM find pass-names...
 	    	List passwords that match pass-names.
+	    $PROGRAM search pass-names...
+	    	Search for password info.txt files containing search-string whitout decrypting password files and return mathced pass-names.
 	    $PROGRAM [show] [--clip[=line-number],-c[line-number]] pass-name
 	        Show existing password and optionally put it on the clipboard.
 	        If put on the clipboard, it will be cleared in $CLIP_TIME seconds.
@@ -365,6 +367,28 @@ cmd_find() {
 	tree -C -l --noreport -P "${terms%|*}" --prune --matchdirs --ignore-case "$PREFIX" | tail -n +2 | sed -E 's/\.gpg(\x1B\[[0-9]+m)?( ->|$)/\1\2/g'
 }
 
+cmd_search(){
+    [[ -z "$@" ]] && die "Usage: $PROGRAM $COMMAND search-term..."
+    local term=""
+    for efile in $(find -L $PREFIX -iname info.txt); do
+	if [[ ! -z $(grep -i $1 $efile) ]]; then
+	    item=$(echo $efile | cut -d"/" -f2-)
+	    while true; do
+		newitem=$(echo $item | cut -d"/" -f2-)
+		item=$(echo $item | cut -d"/" -f-1)
+		if [[ $item == ".password-store" ]]; then
+		    newitem=$(echo $newitem | rev | cut -d"/" -f2- | rev)
+		    break;
+		else
+		    item=$newitem
+		fi
+	    done
+	    term="$term $newitem"
+	fi
+    done
+    cmd_find $term
+}
+
 cmd_grep() {
 	[[ $# -ne 1 ]] && die "Usage: $PROGRAM $COMMAND search-string"
 	local search="$1" passfile grepresults
@@ -635,7 +659,8 @@ case "$1" in
 	help|--help) shift;		cmd_usage "$@" ;;
 	version|--version) shift;	cmd_version "$@" ;;
 	show|ls|list) shift;		cmd_show "$@" ;;
-	find|search) shift;		cmd_find "$@" ;;
+	find) shift;            	cmd_find "$@" ;;
+	search) shift;                  cmd_search "$@";;
 	grep) shift;			cmd_grep "$@" ;;
 	insert|add) shift;		cmd_insert "$@" ;;
 	edit) shift;			cmd_edit "$@" ;;
-- 
2.10.2

